/*TKB's first Library, evolved...


All I knew about writing libraries at the time I did this
came from...

First... good place to start...
   http://playground.arduino.cc/code/library

And then second, to confirm various, learn more...
   http://www.arduino.cc/en/Hacking/LibraryTutorial

*/

#include "NovGrdCore.h" //no ; here. Include the declaration for this class

//const byte LED_PIN = 13; //use the LED @ Arduino pin 13, this should not change so make it const (constant)

//<<constructor>>
NovGrdCore::NovGrdCore(){
	   pinMode(inPUL,INPUT_PULLUP); //make that pin an INPUT, with pullup
       pinMode(inPLL,INPUT_PULLUP);
       //The pins for inPUR. inPLR are ANALOG channelsl and the values
       //in those constants are the ANALOG CHANNEL NUMBER...
       //So it is all rather handy that the pins' modes are
       //  already as we want them,

       pinMode(ouPUL,OUTPUT); //make that pin an OUTPUT
       pinMode(ouPUR,OUTPUT);
       pinMode(ouPLL,OUTPUT);
       pinMode(ouPLR,OUTPUT);
    }

//<<destructor>>
NovGrdCore::~NovGrdCore(){/*nothing to destruct*/}

void NovGrdCore::reportVers()
//One call of Serial.begin(9600) is needed at some point before first use
//of reportVers()
{
//It seems this is not allowed....int iTmp=0;
//(So an itmp is set up in the .h file
iTmp=0;
while (versNovGrdCore[iTmp]!=0){
   Serial.print(versNovGrdCore[iTmp]);
   iTmp++;
   delay(20);
}//end of while
}//end of reportVers

//Make UL output high or low (if bState 0 or not, respectively.)
void NovGrdCore::makeOuUL(byte bState)
{
  if (bState==0)
     {makeOu(0,0);}//no ; here
    else
     {makeOu(0,1);};
}//end of makeOuUL()

void NovGrdCore::makeOuUR(byte bState)
{
  if (bState==0)
     {makeOu(1,0);}//no ; here
    else
     {makeOu(1,1);};
}//end of makeOuUL()


void NovGrdCore::makeOuLL(byte bState)
{
  if (bState==0)
     {makeOu(2,0);}//no ; here
    else
     {makeOu(2,1);};
}//end of makeOuUL()


void NovGrdCore::makeOuLR(byte bState)
{
  if (bState==0)
     {makeOu(3,0);}//no ; here
    else
     {makeOu(3,1);};
}//end of makeOuUL()


void NovGrdCore::makeOu(byte bWhich,byte bState)
{
switch (bWhich) {
case 0:if (bState==0)
        {digitalWrite(ouPUL, LOW);}//no ; here
       else
        {digitalWrite(ouPUL, HIGH);};
//end of else
       break;
       //end of Case 0

case 1:if (bState==0)
        {digitalWrite(ouPUR, LOW);}//no ; here
       else
        {digitalWrite(ouPUR, HIGH);};//end of else
       break;
       //end of Case 1

case 2:if (bState==0)
        {digitalWrite(ouPLL, LOW);}//no ; here
       else
        {digitalWrite(ouPLL, HIGH);};//end of else
       break;
       //end of Case 2

case 3:if (bState==0)
        {digitalWrite(ouPLR, LOW);}//no ; here
       else
        {digitalWrite(ouPLR, HIGH);};//end of else
       break;
       //end of Case 3
  }//end of switch
}//end of makeOu()


boolean NovGrdCore::boInHigh(byte bWhich)
/*Cases 0 and 2 for digial inputs, pulled high
    until button pressed, which pulls them low.
  Cases 1 and 3 for analog inputs, pulled high
    until button pressed, which pulls them low.
  The case numbers chosen for NoviceGuard's
    layout, numbering the inputs in the order
    that printed words would be read.*/

{
switch (bWhich) {
//YES: presented 0,2,1,3... not 0,1,2,3
case 0:if (digitalRead(inPUL)==HIGH)
         {return true;}
        else
         {return false;}//end of else
       break;
       //end of Case 0
case 2:if (digitalRead(inPLL)==HIGH)
         {return true;}
        else
         {return false;}//end of else
       break;
       //end of Case 2

case 1:if (analogRead(inPUR)>127)
       //A low value in case driving LED
       //is depressing Vin. One of 2 instances
         {return true;}
        else
         {return false;}//end of else
       break;
       //end of Case 1

case 3:if (analogRead(inPLR)>127)
       //A low value in case driving LED
       //is depressing Vin Two of 2 instances
         {return true;}
        else
         {return false;}//end of else
       break;
       //end of Case 3

}//end of switch
}//end of boInHigh()


//Scrap just for TKB's use, Only of interest to him.
//Code from someone's example. Keep as it is an example of how
//  to pass code TO a LIBRARY, for use within it....

//blink the LED in a period equal to paramterer -time.
//    void LED13::blink(int time){
//            on();                   //turn LED on
//            delay(time/2);  //wait half of the wanted period
//            off();                  //turn LED off
//            delay(time/2);  //wait the last half of the wanted period
