/*{{HEADER FILE COMMENTS GO HERE}}*/
#ifndef NovGrdCore_H
  #define NovGrdCore_H

  #include <Arduino.h> //It is very important to remember this!
     //Note that if you are using an old Arduino (before 1.0 IDE)
     //    change "Arduino.h" to "WProgram.h"

  class NovGrdCore
  {
     #define versNovGrdCore "0.001" //no ; here;

     #define inPUL 2 //no ; here
     #define inPUR 3 //no ; here ANALOG channel number
     #define inPLL 3 //no ; here
     #define inPLR 2 //no ; here ANALOG channel number

     #define ouPUL 4 //no ; here
     #define ouPUR 13 //no ; here
     #define ouPLL 5 //no ; here
     #define ouPLR 12 //no ; here

     public:
        NovGrdCore();//Constructor
        ~NovGrdCore();//Destructor
        void reportVers();
        void makeOuUL(byte bState);
        void makeOuUR(byte bState);
        void makeOuLR(byte bState);
        void makeOuLL(byte bState);
        void makeOu(byte bWhich,byte bState);
        boolean boInHigh(byte bWhich);


//Scrap just for TKB's use, Only of interest to him.
//Code from someone's example. Keep as it is an example of how
//  to pass code TO a LIBRARY, for use within it....
//void blink(int time);
//      ... is possible.

      private:
        int iTmp;
    };

#endif

